Index: mythcontrols/mythcontrols.cpp
===================================================================
--- mythcontrols/mythcontrols.cpp	(revision 10604)
+++ mythcontrols/mythcontrols.cpp	(working copy)
@@ -401,308 +475,221 @@
 
     UIListBtnTypeItem *b;
     uint len = 1024; // infinity
-    if (list == RightList)
+    if (flist == m_RightList)
     {
         key = key + " ";
         len = key.length();
     }
 
-    for (b = list->GetItemFirst(); b; b = list->GetItemNext(b))
-        if (b->text().left(len) == key) break;
-    if (!b) return false;
+    for (b = flist->GetItemFirst(); b; b = flist->GetItemNext(b))
+    {
+        if (b->text().left(len) == key)
+            break;
+    }
+    if (!b)
+        return false;
 
-    int curpos = list->GetItemPos(list->GetItemCurrent());
-    int newpos = list->GetItemPos(b);
+    int curpos = flist->GetItemPos(flist->GetItemCurrent());
+    int newpos = flist->GetItemPos(b);
 
     if (newpos > curpos)
-        list->MoveDown(newpos - curpos);
+        flist->MoveDown(newpos - curpos);
     else if (newpos < curpos)
-        list->MoveUp(curpos - newpos);
+        flist->MoveUp(curpos - newpos);
     return true;
 }
 
 
-void MythControls::leftSelected(UIListBtnTypeItem*)
+void MythControls::LeftSelected(UIListBtnTypeItem*)
 {
-    LeftList->refresh();
-    RightList->blockSignals(true);
-    refreshRightList();
-    RightList->blockSignals(false);
-    RightList->refresh();
+    m_LeftList->refresh();
+    m_RightList->blockSignals(true);
+    RefreshRightList();
+    m_RightList->blockSignals(false);
+    m_RightList->refresh();
+    m_Description->SetText("");
 }
 
-void MythControls::rightSelected(UIListBtnTypeItem*)
+void MythControls::RightSelected(UIListBtnTypeItem*)
 {
-    RightList->refresh();
-    refreshKeyInformation();
+    m_RightList->refresh();
+    RefreshInformation();
 }
 
+void MythControls::RefreshRight(QStringList * strings)
+{
+    m_RightList->blockSignals(true);
+    m_RightList->Reset();
 
+    strings->sort();
 
+    for (size_t i = 0; i < strings->size(); i++)
+    {
+        UIListBtnTypeItem *item = new UIListBtnTypeItem(m_RightList,(*strings)[i]);
+        item->setDrawArrow(false);
+    }
+
+    m_RightList->blockSignals(false);
+    m_RightList->refresh();
+}
+
 /* method description in header */
-void MythControls::refreshRightList()
+void MythControls::RefreshLeft(QStringList * strings)
 {
-    RightList->Reset();
+    m_LeftList->blockSignals(true);
+    m_LeftList->Reset();
 
-    if (LeftList->GetItemCurrent() == NULL)
-        return;
+    /* sort the strings */
+    strings->sort();
 
-    if (leftType == kContextList)
+    for (size_t i = 0; i < strings->size(); i++)
     {
-        if (rightType == kActionList)
-        {
-            /* add all of the actions to the context list */
-            QString context = LeftList->GetItemCurrent()->text();
-            QStringList *actions = m_contexts[context];
-            if (actions == NULL)
-            {
-                VERBOSE(VB_IMPORTANT, QString("MythControls: Unable to find actions for context %1").arg(context));
-                return;
-            }
-            UIListBtnTypeItem *item;
-            for (size_t i = 0; i < actions->size(); i++)
-                item = new UIListBtnTypeItem(RightList, (*actions)[i]);
-        }
-        else if (rightType == kKeyList)
-        {
-            /* add all of the actions to the context list */
-            QString context = LeftList->GetItemCurrent()->text();
-            BindingList *list = contextKeys[context];
-            if (list == NULL)
-            {
-                VERBOSE(VB_IMPORTANT, QString("MythControls: Unable to find keys for context %1").arg(context));
-                return;
-            }
-            UIListBtnTypeItem *item;
-            for (BindingList::iterator it = list->begin(); it != list->end(); ++it)
-            {
-                binding_t *b = *it;
-                item = new UIListBtnTypeItem(RightList, KeyToDisplay(b->key) + " => " + b->action);
-            }
-        }
-    } else if (leftType == kKeyList && rightType == kContextList)
-    {
-        QString key = DisplayToKey(LeftList->GetItemCurrent()->text());
-        BindingList *list = keyActions[key];
-        if (list == NULL)
-        {
-            VERBOSE(VB_IMPORTANT, QString("MythControls: Unable to find actions for key %1").arg(key));
-            return;
-        }
-        UIListBtnTypeItem *item;
-        BindingList::iterator it = list->begin();
-        binding_t *b = *it;
-        for (size_t i = 0; i < contexts.size(); i++)
-        {
-            QString context = contexts[i];
-            QString action = "<none>";
-            if (b && b->context == context)
-            {
-                action = b->action;
-                ++it;
-                if (it != list->end()) b = *it;
-                else b = NULL;
-            }
-            item = new UIListBtnTypeItem(RightList, context + " => " + action);
-        }
+        UIListBtnTypeItem *item = new UIListBtnTypeItem(m_LeftList, (*strings)[i]);
+        item->setDrawArrow(true);
     }
+
+    m_LeftList->blockSignals(false);
+    m_LeftList->refresh();
 }
 
 
-/* comments in header */
-void MythControls::refreshKeyInformation()
+/* method description in mythcontrols.h */
+void MythControls::RefreshRightList()
 {
-    /* get the description of the current action */
-    QString desc;
+    QStringList *rstrings = NULL;
+    QString lstring = m_LeftList->GetItemCurrent()->text();
 
-    if (focused == LeftList)
+    /* right list, based on values from the left */
+    switch (m_View)
     {
-        /* blank all keys on the context */
-        for (size_t i = 0; i < Action::MAX_KEYS; i++)
-            ActionButtons[i]->setText("");
+    case ActionsByContext:
+        this->ShowButtons(true);
+        rstrings = m_KeyBindings->GetActions(lstring);
+        break;
+    case ActionsByKey:
+        this->ShowButtons(false);
+        rstrings = m_KeyBindings->GetKeyActions(lstring);
+        break;
+    case ContextsByKey:
+        this->ShowButtons(false);
+        rstrings = m_KeyBindings->GetContexts(lstring);
+        break;
     }
-    else if (leftType == kKeyList || rightType == kKeyList)
-    { // Should show appropriate description 
-        QString action = getCurrentAction();
-        QString context = getCurrentContext();
-        /* blank all keys on the context */
-        for (size_t i = 0; i < Action::MAX_KEYS; i++)
-            ActionButtons[i]->setText("");
-        if (!action.isEmpty())
-            {
-    
-            desc = key_bindings->getActionDescription(context, action);
-    
-            BindingList *list = NULL;
-            if (leftType == kKeyList && rightType == kContextList)
-            {
-                QString key = getCurrentKey();
-                list = keyActions[DisplayToKey(key)];
-            }
-            else if (leftType == kContextList && rightType == kKeyList)
-                list = contextKeys[context];
-            if (list)
-            {
-                QString searchKey;
-                if (rightType == kContextList)
-                    searchKey = context;
-                else if (rightType == kActionList)
-                    searchKey = action;
-                else if (rightType == kKeyList)
-                    searchKey = DisplayToKey(getCurrentKey());
-                binding_t *binding = NULL;
-                for (BindingList::iterator it = list->begin(); it != list->end(); ++it)
-                {
-                    binding_t *b = *it;
-                    switch (rightType)
-                    {
-                        case kContextList:
-                            if (b->context == searchKey) binding = b;
-                            break;
-                        case kActionList:
-                            if (b->action == searchKey) binding = b;
-                            break;
-                        case kKeyList:
-                            if (b->key == searchKey) binding = b;
-                            break;
-                    }
-                    if (binding) break;
-                }
-    
-                if (binding)
-                {
-                    if (desc.isEmpty() && context != binding->contextFrom)
-                        desc = key_bindings->getActionDescription(binding->contextFrom, action);
-                    desc += "\n" + tr("Binding comes from %1 context")
-                            .arg(binding->contextFrom);
-                }
-            }
-        }
-    } else {
-        QString context = getCurrentContext();
-        QString action = getCurrentAction();
-        /* set the description */
-        desc = key_bindings->getActionDescription(getCurrentContext(),
-                                                  getCurrentAction());
 
-        /* get the bindings of the current action */
-        QStringList keys = key_bindings->getActionKeys(getCurrentContext(),
-                                                       getCurrentAction());
+    RefreshRight(rstrings);
+    delete rstrings;
+}
 
-        size_t i;
 
-        /* fill existing keys */
-        for (i = 0; i < keys.count(); i++)
-            ActionButtons[i]->setText(KeyToDisplay(keys[i]));
+void MythControls::RefreshBindingInformation()
+{
+    QString context = m_LeftList->GetItemCurrent()->text();
+    QString action = m_RightList->GetItemCurrent()->text();
+    QString desc = m_KeyBindings->GetActionDescription(GetCurrentContext(),
+                                                       GetCurrentAction());
 
-        /* blank the other ones */
-        for (; i < Action::MAX_KEYS; i++)
-            ActionButtons[i]->setText("");
-    }
+    /* get the bindings of the current action */
+    QStringList keys = m_KeyBindings->GetActionKeys(GetCurrentContext(),
+                                                    GetCurrentAction());
 
-    /* set the information */
-    description->SetText(desc);
+    FillButtons(keys);
+
+    m_Description->SetText(desc);
 }
 
 
-
-/* comments in header */
-QString MythControls::getCurrentContext(void) const
+/* method description in mythcontrols.h */
+void MythControls::RefreshInformation()
 {
-    if (leftType == kContextList)
-        return LeftList->GetItemCurrent()->text();
-    if (focused == LeftList) return "";
-
-    QString desc = RightList->GetItemCurrent()->text();
-    int loc = desc.find(" => ");
-    if (loc == -1) return ""; // Should not happen
-    if (rightType == kContextList) return desc.left(loc);
-    else return desc.mid(loc+4);
+    switch (m_View)
+    {
+    case ActionsByContext:
+        if (m_Focused == m_LeftList)
+        {
+            BlankButtons();
+            m_Description->SetText("");
+        }
+        else
+            RefreshBindingInformation();
+        break;
+    case ActionsByKey:
+        if (m_Focused == m_LeftList)
+            m_Description->SetText("");
+        else
+        {
+            QString key = m_LeftList->GetItemCurrent()->text();
+            QString action = m_RightList->GetItemCurrent()->text();
+            int pos = m_RightList->GetItemPos(m_RightList->GetItemCurrent());
+            QString context = m_KeyBindings->GetContext(key, action, pos);
+            QString desc = m_KeyBindings->GetActionDescription(context, action);
+            desc += "\n" + tr("Binding comes from %1 context").arg(context);
+            m_Description->SetText(desc);
+        }
+        break;
+    case ContextsByKey:
+        if (m_Focused == m_LeftList)
+            m_Description->SetText("");
+        else
+        {
+            QString key = m_LeftList->GetItemCurrent()->text();
+            QString context = m_RightList->GetItemCurrent()->text();
+            QString action = m_KeyBindings->GetAction(key, context);
+            QString desc = action + ": " +
+                m_KeyBindings->GetActionDescription(context, action);
+            m_Description->SetText(desc);
+        }
+        break;
+    }
 }
 
 /* comments in header */
-QString MythControls::getCurrentAction(void) const
+QString MythControls::GetCurrentContext(void) const
 {
-    if (leftType == kActionList)
-        return LeftList->GetItemCurrent()->text();
-    if (focused == LeftList) return "";
-
-    QString desc = RightList->GetItemCurrent()->text();
-    if (leftType == kContextList && rightType == kActionList)
-        return desc;
-    int loc = desc.find(" => ");
-    if (loc == -1) return ""; // Should not happen
-    if (rightType == kActionList) return desc.left(loc);
+    if (m_View == ActionsByContext)
+        return m_LeftList->GetItemCurrent()->text();
+    else if ((m_View == ContextsByKey) && (m_Focused == m_RightList))
+        return m_RightList->GetItemCurrent()->text();
     else
-    {
-        QString rv = desc.mid(loc+4);
-        if (rv == "<none>") return "";
-        else return rv;
-    }
+        return "";
 }
 
 /* comments in header */
-QString MythControls::getCurrentKey(void) const
+QString MythControls::GetCurrentAction(void) const
 {
-    if (leftType == kKeyList)
-        return LeftList->GetItemCurrent()->text();
-    if (focused == LeftList) return "";
 
-    if (leftType == kContextList && rightType == kActionList)
-    {
-        QString context = getCurrentContext();
-        QString action = getCurrentAction();
-        size_t b = focusedButton();
-        QStringList keys = key_bindings->getActionKeys(context, action);
-        if (b < keys.count()) return keys[b];
-        else return "";
-    }
-
-    QString desc = RightList->GetItemCurrent()->text();
-    int loc = desc.find(" => ");
-    if (loc == -1) return ""; // Should not happen
-    if (rightType == kKeyList) return desc.left(loc);
-    else return desc.mid(loc+4);
+    if (((m_View == ActionsByContext) && (m_Focused != m_LeftList)) ||
+        ((m_View == ActionsByKey) && (m_Focused == m_RightList)))
+        return m_RightList->GetItemCurrent()->text();
+    else
+        return "";
 }
 
-
 /* comments in header */
-void MythControls::loadHost(const QString & hostname) {
-
-    /* create the key bindings and the tree */
-    key_bindings = new KeyBindings(hostname);
-    contexts = *key_bindings->getContexts();
-
-    keys.clear();
-
-    /* Alphabetic order, but jump and global at the top  */
-    contexts.sort();
-    contexts.remove(JUMP_CONTEXT);
-    contexts.remove(GLOBAL_CONTEXT);
-    contexts.insert(contexts.begin(), 1, GLOBAL_CONTEXT);
-    contexts.insert(contexts.begin(), 1, JUMP_CONTEXT);
-
-    QStringList *actions;
-    for (size_t i = 0; i < contexts.size(); i++)
+QString MythControls::GetCurrentKey(void) const
+{
+    if (m_View == ActionsByContext)
     {
-        actions = key_bindings->getActions(contexts[i]);
-        actions->sort();
-        m_contexts.insert(contexts[i], actions);
+        QString context = GetCurrentContext();
+        QString action = GetCurrentAction();
+        size_t b = FocusedButton();
+        QStringList keys = m_KeyBindings->GetActionKeys(context, action);
+        if (b < keys.count())
+            return keys[b];
+        else
+            return "";
     }
-
-    refreshKeyBindings();
-    updateLists();
+    else
+        return m_LeftList->GetItemCurrent()->text();
 }
 
-
-
 /* comments in header */
-void MythControls::deleteKey()
+void MythControls::DeleteKey()
 {
     // This code needs work to support deleteKey in any mode exc. Context/Action
-    QString context = getCurrentContext();
-    QString key = getCurrentKey();
-    QString action = getCurrentAction();
+    QString context = GetCurrentContext();
+    QString key = GetCurrentKey();
+    QString action = GetCurrentAction();
+
     if (context.isEmpty() || key.isEmpty() || action.isEmpty())
     {
         InvalidBindingPopup popup(gContext->GetMainWindow());
@@ -710,52 +697,31 @@
         return;
     }
 
-    BindingList *list = keyActions[key];
-    binding_t *binding = NULL;
-    for (BindingList::iterator it = list->begin(); it != list->end(); ++it)
+    if (m_View == ActionsByContext)
     {
-        binding_t *b = *it;
-        if (b->context == context) binding = b;
+        QString trtext =
+            tr("Delete this key binding from context %1?").arg(context);
+        ConfirmMenu popup(gContext->GetMainWindow(), trtext);
+        if (popup.getOption() != ConfirmMenu::CONFIRM)
+            return;
+        else
+        {
+            m_KeyBindings->RemoveActionKey(context, action, key);
+        }
     }
-    if (!binding)
-    {
-        InvalidBindingPopup popup(gContext->GetMainWindow());
-        popup.getOption();
-        return;
-    }
 
-    if (binding->contextFrom != context)
-    {
-        ConfirmMenu popup(gContext->GetMainWindow(), tr("Delete this key binding from context %1?").arg(binding->contextFrom));
-        if (popup.getOption() != ConfirmMenu::CONFIRM) return;
-    } else {
-        ConfirmMenu popup(gContext->GetMainWindow(), tr("Delete this binding?"));
-        if (popup.getOption() != ConfirmMenu::CONFIRM) return;
-    }
-
-    if (!key_bindings->removeActionKey(binding->contextFrom, action, key))
-    {
-        InvalidBindingPopup popup(gContext->GetMainWindow());
-        popup.getOption();
-        return;
-    }
-
-    // refreshing everything is overkill.  I tried incrementally updating, but the
-    // code was ugly.  Since this is quick in my experience, overkill away!
-    refreshKeyBindings();
-    refreshKeyInformation();
+    RefreshInformation();
 }
 
 /* method description in header */
-bool MythControls::resolveConflict(ActionID *conflict, int level)
+bool MythControls::ResolveConflict(ActionID *conflict, int level)
 {
     MythMainWindow *window = gContext->GetMainWindow();
 
     /* prevent a fatal binding */
     if (level == KeyBindings::Error)
     {
-        InvalidBindingPopup popup(gContext->GetMainWindow(),
-                                  conflict->action(),
+        InvalidBindingPopup popup(gContext->GetMainWindow(), conflict->action(),
                                   conflict->context());
         popup.getOption();
         return false;
@@ -778,9 +744,8 @@
 
 
 /* method description in header */
-void MythControls::addKeyToAction(void)
+void MythControls::AddKeyToAction(void)
 {
-    // This code needs work to support deleteKey in any mode exc. Context/Action
     /* grab a key from the user */
     KeyGrabPopupBox *kg = new KeyGrabPopupBox(gContext->GetMainWindow());
     int result = kg->ExecPopup(kg,SLOT(cancel()));
@@ -788,238 +753,41 @@
     delete kg;
 
     /* go no further if canceled */
-    if (result == 0) return;
+    if (result == 0)
+        return;
 
     /* get the keys for the selected action */
-    size_t b = focusedButton();
-    QString action = getCurrentAction(), context = getCurrentContext();
-    QStringList keys = key_bindings->getActionKeys(context, action);
+    size_t b = FocusedButton();
+    QString action = GetCurrentAction(), context = GetCurrentContext();
+    QStringList keys = m_KeyBindings->GetActionKeys(context, action);
 
     /* dont bother rebinding the same key */
-    if (keys[b] == key) return;
+    if (keys[b] == key)
+        return;
 
     bool bind = true;
     int level;
 
     /* get the potential conflict */
     ActionID *conflict = NULL;
-    if ((conflict = key_bindings->conflicts(context, key, level)))
-        bind = resolveConflict(conflict, level);
+    if ((conflict = m_KeyBindings->Conflicts(context, key, level)))
+        bind = ResolveConflict(conflict, level);
 
     delete conflict;
 
     /* dont bind if we shouldn't bind */
-    if (!bind) return;
+    if (!bind)
+        return;
 
     /* finally bind or rebind a key to the action */
     if (b < keys.count())
-        key_bindings->replaceActionKey(context,action, key, keys[b]);
+        m_KeyBindings->ReplaceActionKey(context,action, key, keys[b]);
     else
-        key_bindings->addActionKey(context, action, key);
+        m_KeyBindings->AddActionKey(context, action, key);
 
-    refreshKeyBindings();
-    refreshKeyInformation();
+    RefreshInformation();
 }
 
-
-
-void MythControls::addBindings(QDict<binding_t> &bindings,
-                               const QString &context,
-                               const QString &contextParent, int bindlevel)
-{
-    QStringList *actions = key_bindings->getActions(context);
-
-    for (size_t i = 0; i < actions->size(); i++)
-    {
-        QString action = (*actions)[i];
-        QStringList keys = key_bindings->getActionKeys(context, action);
-
-        for (size_t j = 0; j < keys.size(); j++)
-        {
-            QString key = keys[j];
-
-            binding_t *b = bindings.find(key);
-            if (!b) 
-            {
-                b = new(binding_t);
-                b->key = key;
-                b->action = action;
-                b->context = contextParent;
-                b->contextFrom = context;
-                b->bindlevel = bindlevel;
-                bindings.insert(key, b);
-            }
-            else if (b->bindlevel == bindlevel)
-            {
-                b->action += ", " + action;
-            }
-        }
-    }
-}
-
-BindingList *MythControls::getKeyBindings(const QString &context)
-{
-    QStringList keys;
-    QDict<binding_t> bindings;
-    bindings.clear();
-
-    for (size_t i = 0; i < contexts.size(); i++)
-        addBindings(bindings, contexts[i], context, i);
-
-
-    for (QDictIterator<binding_t> it(bindings); it.current(); ++it)
-    {
-        QString key = it.currentKey();
-        keys.append(key);
-    }
-
-    sortKeyList(keys);
-
-    BindingList *retval = new BindingList;
-    retval->clear();
-
-    for (QStringList::Iterator kit = keys.begin(); kit != keys.end(); ++kit)
-    {
-        QString key = *kit;
-        retval->append(bindings[key]);
-    }
-    retval->setAutoDelete(true);
-    return retval;
-}
-
-void MythControls::refreshKeyBindings()
-{
-    contextKeys.clear();
-    keyActions.clear();
-    for (size_t i = 0; i < contexts.size(); i++)
-    {
-        QString context = contexts[i];
-        BindingList *list = getKeyBindings(context);
-        contextKeys.insert(context, list);
-        for (BindingList::iterator it = list->begin(); it != list->end(); ++it)
-        {
-            binding_t *b = *it;
-            BindingList *list = keyActions.find(b->key);
-            if (!list)
-            {
-                list = new BindingList;
-                list->clear();
-                keyActions.insert(b->key, list);
-            }
-            keys.append(b->key);
-            list->append(b);
-        }
-    }
-    contextKeys.setAutoDelete(true);
-    keyActions.setAutoDelete(true);
-
-    sortKeyList(keys);
-}
-
-void MythControls::sortKeyList(QStringList &keys)
-{
-    QStringList t;
-    t.clear();
-
-    for ( QStringList::Iterator it = keys.begin(); it != keys.end(); ++it )
-    {
-        QString key = *it;
-
-        QString keydesc = "3 ";
-        if (key.left(6) == "remote")
-        {
-            keydesc = "0 ";
-        }
-        else if (key.length() == 1)
-        {
-            switch (key[0].category())
-            {
-                case QChar::Letter_Uppercase:
-                    keydesc = "2 ";
-                    break;
-                case QChar::Number_DecimalDigit:
-                    keydesc = "1 ";
-                    break;
-                default:
-                    keydesc = "5 ";
-                    break;
-            }
-        }
-        else if (key.find("+", 1) != -1)
-            keydesc = "4 ";
-
-        t.push_back(keydesc + key);
-    }
-    t.sort();
-
-    QString prev = "";
-
-    keys.clear();
-    for (QStringList::Iterator kit = t.begin(); kit != t.end(); ++kit)
-    {
-        QString cur = (*kit).mid(2);
-        if (cur != prev) 
-        {
-            keys.append(cur);
-            prev = cur;
-        }
-    }
-}
-
-QString MythControls::getTypeDesc(ListType type)
-{
-    switch (type)
-    {
-        case kContextList:
-            return tr("Contexts");
-            break;
-        case kKeyList:
-            return tr("Keys");
-            break;
-        case kActionList:
-            return tr("Actions");
-            break;
-        default:
-            return "";
-    }
-}
-
-void MythControls::updateLists()
-{
-    RightList->blockSignals(true);
-    LeftList->blockSignals(true);
-    LeftList->Reset();
-    if (leftType == kContextList)
-    {
-        UIListBtnTypeItem *item;
-        for (size_t i = 0; i < contexts.size(); i++)
-        {
-            item = new UIListBtnTypeItem(LeftList, contexts[i]);
-            item->setDrawArrow(true);
-        }
-    } else if (leftType == kKeyList)
-    {
-        UIListBtnTypeItem *item;
-        for (size_t i = 0; i < keys.size(); i++)
-        {
-            QString key = KeyToDisplay(keys[i]);
-            item = new UIListBtnTypeItem(LeftList, key);
-            item->setDrawArrow(true);
-        }
-    }
-    refreshRightList();
-    RightList->blockSignals(false);
-    LeftList->blockSignals(false);
-    LeftList->refresh();
-    RightList->refresh();
-
-    if (LeftDesc != NULL)
-        LeftDesc->SetText(getTypeDesc(leftType));
-    if (RightDesc != NULL)
-        RightDesc->SetText(getTypeDesc(rightType));
-}
-
-
 #endif /* MYTHCONTROLS_CPP */
 
 /* vim: set expandtab tabstop=4 shiftwidth=4: */
